/*
 * SemaforoDeGiro.cpp
 *
 *  Created on: 26-07-2019
 *  Author: Matias Contreras, Camilo Fernandez, Maria Rivas
 */

#include "SemaforoDeGiro.h"

SemaforoDeGiro::SemaforoDeGiro(){
	greenTime = blinkingTime = 0;
}

SemaforoDeGiro::SemaforoDeGiro(int gt, int bt){
	greenTime = gt;          // constructor de la clase
	blinkingTime = bt;
}

void SemaforoDeGiro::turnGreenLightOn(){
	state = "follow";        // enciende luz verde
}

void SemaforoDeGiro::turnGreenLightOff(){
	state = "stop";      // enciende luz roja
}

void SemaforoDeGiro::turnBlinkingOn(){
	state = "blinking";   // inicia el parpadeo
}

int SemaforoDeGiro::getGreenLightTime(){
	return greenTime;     // obtiene tiempo de luz verde
}

int SemaforoDeGiro::getBlinkingTime(){
	return blinkingTime; // obtiene tiempo de intermitencia
}

string SemaforoDeGiro::toString(){
	if(state == "stop"){ return ("R"); }   // Luz roja
	else if(state == "follow"){ return ("V"); }  // Luz verde
	else if(state == "blinking"){ return ("P"); }    // Luz parpadeando
	else{ return "!"; }
}

SemaforoDeGiro::~SemaforoDeGiro(){
	// Destructor (eliminan el objeto de esta clase)
}
