/*
 * TestStage3.cpp
 *
 *  Created on: 18-07-2019
 *  Author: Matias Contreras, Camilo Fernandez, Maria Rivas
 */

#include "SemaforoDeGiro.h"
#include "DetectorDeRequerimiento.h"
#include "SimuladorEntradas.h"
#include "Controlador.h"
#include "MyTimer.h"

#include <iostream>			// Biblioteca para la entrada y salida de datos
#include <fstream>			// Biblioteca para el tratamiendo de archivos
#include <unistd.h>			// Biblioteca para utilizar el metodo sleep()
#include <string.h>			// Biblioteca para el uso de cadenas de caracteres
using namespace std;

int main(int argc, char *argv[]){
	ifstream file;
	string data, aux, out;
	int followTimeTurn = 6;
	int transitionTimeTurn = 4;

	if(argc != 2){
		cout << "Usage: ./TestStage3 <name of event input file>\n" << endl;
		return 1;
	}

	file.open(argv[1]);
	if(file.fail()){
		cout << "Error when opening file\n" << endl;
		return 1;
	}

	while(getline(file,aux))		// Lee linea por linea desde file
		out.append(aux);			// Las almacena en un string

	file.close();

	int a = 0;
	char line[out.length()];
	for(int i = 0; i<out.length(); i++){					// Detecta lineas y espacios vacios para
		if(out[i] != '\r'){ line[a] = out[i]; a++; }		// eliminarlos de out y almacenarlos en data
	}

	for(int i = 0; i<strlen(line); i++)
		data.push_back(line[i]);

	SemaforoDeGiro *semGiro = new SemaforoDeGiro(followTimeTurn, transitionTimeTurn);
	DetectorDeRequerimiento *sensor = new DetectorDeRequerimiento();
	SimuladorEntradas *simulator = new SimuladorEntradas(sensor, data);
	Controlador *controller = new Controlador(semGiro, sensor);
	MyTimer *timer = new MyTimer(1000, simulator);

	cout << " \tA" << endl;
	simulator->actionPerformed();
	for(int i = 0; i<data.length(); i++)
		controller->manageTraffic();
	
	timer->stop();
	delete semGiro, sensor, simulator, controller, timer;
	return 0;
}
