/*
 * Controlador.cpp
 *
 *  Created on: 24-07-2019
 *  Author: Matias Contreras, Camilo Fernandez, Maria Rivas
 */

#include "Controlador.h"

Controlador::Controlador(){
	time = 0;
	cont = 1;
	this->A = NULL;
	this->B = NULL;
	this->one = NULL;
	this->two = NULL;
	this->three = NULL;
	this->four = NULL;
	this->five = NULL;
	this->sensor = NULL;
	this->button = NULL;
}

Controlador::Controlador(SemaforoP *a, SemaforoP *b, StreetTrafficLight *uno, 
			SemaforoDeGiro *dos, StreetTrafficLight *tres, SemaforoDeGiro *cuatro, 
			StreetTrafficLight *cinco, DetectorDeRequerimiento *ind, DetectorDeRequerimiento *bt){
	time = 0;
	cont = 1;
	this->A = a;
	this->B = b;
	this->one = uno;
	this->two = dos;
	this->three = tres;
	this->four = cuatro;
	this->five = cinco;
	this->sensor = ind;
	this->button = bt;
}

void Controlador::manageTraffic(){
	if(button->isON() && sensor->isON()){
		A->turnGreenLightOn();
		B->turnRedLightOn();
		one->turnStop();
		two->turnGreenLightOn();
		three->turnStop();
		four->turnGreenLightOn();
		five->turnStop();

		if((A->getGreenLightTime() >= two->getGreenLightTime()) && (A->getGreenLightTime() >= four->getGreenLightTime())){
			time = A->getGreenLightTime();

		}else if((two->getGreenLightTime() >= four->getGreenLightTime()) && (two->getGreenLightTime() >= A->getGreenLightTime())){
			time = two->getGreenLightTime();

		}else if((four->getGreenLightTime() >= two->getGreenLightTime()) && (four->getGreenLightTime() >= A->getGreenLightTime())){
			time = four->getGreenLightTime();
		}

		for(int i = 0; i<time; i++){
			cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
					<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
			sleep(1);
			cont++;
		}

		A->turnBlinkingOn();
		two->turnBlinkingOn();
		four->turnBlinkingOn();

		if((A->getBlinkingTime() >= two->getBlinkingTime()) && (A->getBlinkingTime() >= four->getBlinkingTime())){
			time = A->getBlinkingTime();

		}else if((two->getBlinkingTime() >= four->getBlinkingTime()) && (two->getBlinkingTime() >= A->getBlinkingTime())){
			time = two->getBlinkingTime();

		}else if((four->getBlinkingTime() >= two->getBlinkingTime()) && (four->getBlinkingTime() >= A->getBlinkingTime())){
			time = four->getBlinkingTime();
		}

		for(int i = 0; i<time; i++){
			cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
					<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
			sleep(1);
			cont++;
		}

		A->turnRedLightOn();
		two->turnRedLightOn();
		four->turnRedLightOn();

	}else if(button->isON() && !sensor->isON()){
		A->turnGreenLightOn();
		B->turnRedLightOn();
		one->turnFollow();
		two->turnGreenLightOn();
		three->turnStop();
		four->turnRedLightOn();
		five->turnStop();

		if((A->getGreenLightTime() >= one->getFollowTime()) && (A->getGreenLightTime() >= two->getGreenLightTime())){
			time = A->getGreenLightTime();

		}else if((one->getFollowTime() >= two->getGreenLightTime()) && (one->getFollowTime() >= A->getGreenLightTime())){
			time = one->getFollowTime();

		}else if((two->getGreenLightTime() >= one->getFollowTime()) && (two->getGreenLightTime() >= A->getGreenLightTime())){
			time = two->getGreenLightTime();
		}

		for(int i = 0; i<time; i++){
			cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
					<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
			sleep(1);
			cont++;
		}

		A->turnBlinkingOn();
		one->turnTransition();
		two->turnBlinkingOn();

		if((A->getBlinkingTime() >= one->getTransitionTime()) && (A->getBlinkingTime() >= two->getBlinkingTime())){
			time = A->getBlinkingTime();

		}else if((one->getTransitionTime() >= two->getBlinkingTime()) && (one->getTransitionTime() >= A->getBlinkingTime())){
			time = one->getTransitionTime();

		}else if((two->getBlinkingTime() >= one->getTransitionTime()) && (two->getBlinkingTime() >= A->getBlinkingTime())){
			time = two->getBlinkingTime();
		}

		for(int i = 0; i<time; i++){
			cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
					<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
			sleep(1);
			cont++;
		}

		A->turnRedLightOn();
		one->turnStop();
		two->turnRedLightOn();

	}else if(!button->isON() && sensor->isON()){
		A->turnRedLightOn();
		B->turnRedLightOn();
		one->turnStop();
		two->turnGreenLightOn();
		three->turnStop();
		four->turnGreenLightOn();
		five->turnFollow();

		if((two->getGreenLightTime() >= four->getGreenLightTime()) && (two->getGreenLightTime() >= five->getFollowTime())){
			time = two->getGreenLightTime();

		}else if((four->getGreenLightTime() >= two->getGreenLightTime()) && (four->getGreenLightTime() >= five->getFollowTime())){
			time = four->getGreenLightTime();
		
		}else if((five->getFollowTime() >= two->getGreenLightTime()) && (five->getFollowTime() >= four->getGreenLightTime())){
			time = five->getFollowTime();
		}

		for(int i = 0; i<time; i++){
			cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
					<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
			sleep(1);
			cont++;
		}

		two->turnBlinkingOn();
		four->turnBlinkingOn();
		five->turnTransition();

		if((two->getBlinkingTime() >= four->getBlinkingTime()) && (two->getGreenLightTime() >= five->getTransitionTime())){
			time = two->getBlinkingTime();

		}else if((four->getBlinkingTime() >= two->getBlinkingTime()) && (four->getBlinkingTime() >= five->getTransitionTime())){
			time = four->getBlinkingTime();
		
		}else if((five->getTransitionTime() >= two->getBlinkingTime()) && (five->getTransitionTime() >= four->getGreenLightTime())){
			time = five->getTransitionTime();
		}

		for(int i = 0; i<time; i++){
			cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
					<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
			sleep(1);
			cont++;
		}

		two->turnRedLightOn();
		four->turnRedLightOn();
		five->turnStop();

	}else if(!button->isON() && !sensor->isON()){
		A->turnRedLightOn();
		B->turnGreenLightOn();
		one->turnStop();
		two->turnRedLightOn();
		three->turnFollow();
		four->turnRedLightOn();
		five->turnFollow();

		if((B->getGreenLightTime() > three->getFollowTime()) && (B->getGreenLightTime() > five->getFollowTime())){
			time = B->getGreenLightTime();

		}else if((three->getFollowTime() > five->getFollowTime()) && (three->getFollowTime() > B->getGreenLightTime())){
			time = three->getFollowTime();

		}else if((five->getFollowTime() > three->getFollowTime()) && (five->getFollowTime() > B->getGreenLightTime())){
			time = five->getFollowTime();
		}

		for(int i = 0; i<time; i++){
			cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
					<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
			sleep(1);
			cont++;
		}

		B->turnBlinkingOn();
		three->turnTransition();
		five->turnTransition();

		if((B->getBlinkingTime() > three->getTransitionTime()) && (A->getBlinkingTime() > five->getTransitionTime())){
			time = B->getBlinkingTime();

		}else if((three->getTransitionTime() > five->getTransitionTime()) && (three->getTransitionTime() > B->getBlinkingTime())){
			time = three->getTransitionTime();

		}else if((five->getTransitionTime() > three->getTransitionTime()) && (five->getTransitionTime() > A->getBlinkingTime())){
			time = five->getTransitionTime();
		}

		for(int i = 0; i<time; i++){
			cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
					<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
			sleep(1);
			cont++;
		}

		B->turnRedLightOn();
		three->turnStop();
		five->turnStop();

	}else{
		A->turnRedLightOn();
		B->turnRedLightOn();
		one->turnStop();
		two->turnRedLightOn();
		three->turnStop();
		four->turnRedLightOn();
		five->turnStop();

		cout << cont << "\t" << A->toString() << "\t" << B->toString() << "\t" << one->toString() << "\t" 
				<< two->toString() << "\t" << three->toString() << "\t" << four->toString() << "\t" << five->toString() << endl;
		sleep(1);
		cont++;
	}
}

Controlador::~Controlador(){		// Destructor (eliminan el objeto de esta clase)
	delete A, B, one, two, three, four, five, sensor, button;
}
