/*
 * TrafficLight.cpp
 *
 *  Created on: 18-07-2019
 *  Author: Matias Contreras, Camilo Fernandez, Maria Rivas
 */

#include "TrafficLight.h"

TrafficLight::TrafficLight(){
	stopTime = followTime = transitionTime = 0;
}

TrafficLight::TrafficLight(int st, int ft, int tt){
	stopTime = st;
	followTime = ft;
	transitionTime = tt;
}

void TrafficLight::turnStop(){
	state = "stop";
}

void TrafficLight::turnTransition(){
	state = "transition";
}

void TrafficLight::turnFollow(){
	state = "follow";
}

int TrafficLight::getStopTime(){
	return stopTime;
}

int TrafficLight::getFollowTime(){
	return followTime;
}

int TrafficLight::getTransitionTime(){
	return transitionTime;
}

string TrafficLight::toString(){
	if(state == "stop"){ return "R"; }
	else if(state == "transition"){ return "A"; }
	else if(state == "follow"){ return "V"; }
	else{ return "!"; }
}

TrafficLight::~TrafficLight(){
	// Destructor (eliminan el objeto de esta clase)
}


